import javax.swing.text.StyledEditorKit;
import java.util.*;

// This class implements 'GradingCollection' and represents a list of gradings of a single student, i.e.,
// all gradings in this list must have an equal 'matriculationID'.
// The entries are in order in which they have been added.
// (The most recently added element is the last element of the list.)
// Iterator and 'toString' follow that order.
public class SingleStudentGradingList implements GradingCollection/* TODO: fix declaration */ {
    // $ 20 von 20 Punkten für SingleStudentGradingList

    //TODO: implement methods and define missing parts of this class. You can use the Java-Collection-Framework.
    private int matriculationID;
    private ArrayList<Grading> gradingList;

    // Initializes this list with the 'matriculationID' of the student.
    public SingleStudentGradingList(int matriculationID) {
        //TODO: implement this constructor.
        this.matriculationID = matriculationID;
        this.gradingList = new ArrayList<>();
    }

    // Ensures that this list contains the specified 'grading', if the grading belongs to the student of this list.
    // If this list already contains the specified 'grading' or the grading does not belong to this
    // student, this list is not changed.
    public boolean add(Grading grading) {
        //TODO: implement this method.
        if (!gradingList.contains(grading) && grading.getMatriculationID() == this.matriculationID) {
            gradingList.add(grading);
            return true;
        }
        return false;
    }

    // If the specified 'matriculationID' is the same as that of this list, a copy of this list is returned,
    // otherwise an empty list is returned (with the specified 'matriculationID').
    public SingleStudentGradingList filter(int matriculationID) {
        //TODO: implement this method.
        SingleStudentGradingList copyList = new SingleStudentGradingList(matriculationID);

        for (Grading i : gradingList) {
            if (i.getMatriculationID() == matriculationID) {
                copyList.add(i);
            }
        }
        return copyList;
    }

    @Override
    public String toString() {
        String s = "";

        for (Grading i : gradingList) {
            s += i.toString() + "\n";
        }
        return s;
    }

    @Override
    public GradingIterator iterator() {
        return new GradingIterator() {
            private Iterator<Grading> gradingIterator = gradingList.iterator();

            @Override
            public Grading next() {
                if(gradingIterator.hasNext()) {
                    return gradingIterator.next();
                } else {
                    throw new NoSuchElementException("Kein Zeugnis verfügbar!");
                }
            }

            @Override
            public boolean hasNext() {
                return gradingIterator.hasNext();
            }
        };
    }
}

